#include <assert.h>
#include <values.h>
#include "objet.h"
#include "cluster_set.h"
#include "cag.h"

#define Nb_clusters SELF(nb_clusters)
#define Size        SELF(size)
#define Exist       SELF(exist)
#define Links       SELF(links)
#define Min         SELF(min)

static void make_links_priv(cag,cluster_set);
static int get_min_priv(cag,int);

struct cag
{
  int nb_clusters;
  int size;
  bouleen *exist;
  double* links;
  int* min;
};

cag FAIRE_cag(cluster_set clusters)
{

  INSTANCIER(cag);
  
  Nb_clusters = cluster_set_give_cardinal(clusters);
  Size  = Nb_clusters*(Nb_clusters-1)/2;
  Exist = (bouleen*)malloc(Nb_clusters*sizeof(bouleen));  
  Min   = (int*)    malloc(Nb_clusters*sizeof(int));
  Links = (double*) malloc(Size*sizeof(double));
  
  make_links_priv(self,clusters);

  return self;
}
void DEFAIRE_cag(cag self)
{
  free(Links);
  free(Exist);
  free(Min);

  free(self);
}

void cag_find_closest_node(cag self,int* clus1,int* clus2)
{
  double *ptr;
  double min_se;
  int i;


  min_se  = DBL_MAX;
  ptr = Links;
  for(i=1;i<Nb_clusters;i++)
    {
      assert(ptr+Min[i] < Links+Size);
      if(Exist[i]&&
	 Exist[Min[i]]&&
	 (*(ptr+Min[i]) < min_se))
	{
	  min_se = *(ptr+Min[i]);
	  *clus1 = i;
	  *clus2 = Min[i];
	}
      ptr+=i;
    }

  assert(min_se != DBL_MAX);
  /*  printf("min = %lf",min_se);*/
}
/* On suppose que clus2 < clus1 */
void cag_merge_node(cag self,cluster_set clusters,int clus1,int clus2)
{
  double *ptr1,*ptr2;
  int ptr_incr;
  int i,min=0;
  double old_val,val_min;

  /* On invalide la ligne clus2 */
  Exist[clus2] = faux;
  Min[clus2]=0;

  ptr1 = Links+ clus1*(clus1-1)/2;
  ptr2 = Links+ clus2*(clus2-1)/2;
  *(ptr1+clus2) = DBL_MAX;

/* On corrige la ligne clus1 */
  val_min = DBL_MAX;
  for(i=0;i<clus2;i++)
    {
      if((*ptr1 != DBL_MAX)||(*ptr2 != DBL_MAX))
	{
	  *ptr1 = cluster_set_get_dist(clusters,clus1,i);
	  if((*ptr1 < val_min)&&Exist[i])
	    {
	      val_min = *ptr1;
	      min = i;
	    }
	}
      ptr1++;
      ptr2++;      
    }
  for(i=clus2;i<clus1;i++)
    {
      if(*ptr1 != DBL_MAX)
	{
	  *ptr1 = cluster_set_get_dist(clusters,clus1,i);
	  if((*ptr1 < val_min)&&Exist[i])
	    {
	      val_min = *ptr1;
	      min = i;
	    }
	}
      ptr1++;
    }

  Min[clus1] = min;

  /* On corrige la collone clus1*/
  ptr1 = Links+clus1*(clus1+1)/2+clus1; /* (clus1+1,clus1) */
  ptr_incr = clus1+1;
  ptr2 = Links+clus1*(clus1+1)/2+clus2; /* (clus1+1,clus2)*/
  for(i=clus1+1;i<Nb_clusters;i++)
    {
      if(Exist[i])
	{
	  old_val = *ptr1;
	  
	  if((*ptr1 != DBL_MAX)||(*ptr2 != DBL_MAX))
	    *ptr1 = cluster_set_get_dist(clusters,clus1,i);
	}
      ptr1 += ptr_incr;
      ptr2 += ptr_incr;
      ptr_incr++;
    }

  for(i=clus2+1;i<Nb_clusters;i++)
    if((Min[i] == clus2)||(Min[i] == clus1))
      Min[i] = get_min_priv(self,i);
  
}
  /***************************************************/
 /* Fonctions prives */
/**************************************************/
static void make_links_priv(cag self,cluster_set clusters)
{
  double* ptr;
  int i,j;
  int min;
  double val_min;

  Min[0] =0;
  Exist[0] = vrai;
  ptr = Links;
  for(i=1;i<Nb_clusters;i++)
    {
      Exist[i] = vrai;
      val_min  = DBL_MAX;
      min =0;
      for(j=0;j<i;j++)
	{
	  *ptr = cluster_set_get_dist(clusters,i,j);
	  if(*ptr < val_min)
	    {
	      val_min = *ptr;
	      min = j;
	    }
	  ptr++;
	}
      Min[i] = min;
    }
}

static int get_min_priv(cag self,int i)
{
  double* ptr = Links + (i*(i-1))/2;
  int j,min=0;
  double min_val=DBL_MAX;
  
  for(j=0;j<i;j++)
    {
      if((*ptr < min_val)&&Exist[j])
	{
	  min_val = *ptr;
	  min = j;
	}
      ptr++;
    }
  return min;
}
  
  



