#include <stdio.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <malloc.h>
#include <time.h>
#include <limits.h>
#include "chrono.h"
#include "lecture_fichier_image.h"
#include "conversion.h"
#include "cluster_set.h"
#include "partition.h"

/*#define DEBUG 1*/
/***********************************************************************/
/* Utilise la table de couleur pour affecter a chaque pixel sa couleur */
/* la plus proche */
/***********************************************************************/
void  map_image(cluster_set clusters,
		image *table_rgb,
		partition init_part,
		image img,
		int nb_color,
		int nb_cluster,
		int espace_choisi)
{
  int i,j;
  int R,G,B;
  int indice_couleur;
  int *pixel;
  int *table_cour;
  int *table_cour_rgb;
  int C[3];
  PFconversion *c1c2c3_to_rgb = revenir_espace(espace_choisi);
  PFconversion *rgb_to_c1c2c3 = changer_espace(espace_choisi);
  int* table_C1C2C3,*equiv;
  vecteur coul;

  table_C1C2C3 = (int*)malloc(3*nb_color*sizeof(int));
  equiv = (int*)malloc(nb_cluster*sizeof(int));
  *table_rgb  = FAIRE_image();

  image_initialize(*table_rgb,3,nb_color,1);
  cluster_set_set_canonic(clusters);
  
/*  *table_rgb = (Comp_rgb*)malloc(sizeof(Comp_rgb)*3*nb_de_couleur);*/
  fprintf(stderr,"nb_clusters : %d\n",nb_cluster);
  fprintf(stderr,"nb_color : %d\n",nb_color);

  cluster_set_give_canonic_clusters(clusters,table_C1C2C3,equiv);
  /* On passe la table de couleurs en RGB */
  table_cour = table_C1C2C3;
  
  image_debut(*table_rgb);
  for(i=0;i<nb_color;i++)
    {

      for(j=0;j<3;j++)
	C[j] = (int)(*(table_cour+j));

      /* On calcul et minore */
      
      R= c1c2c3_to_rgb[0](C[0],C[1],C[2]);
      G= c1c2c3_to_rgb[1](C[0],C[1],C[2]);
      B= c1c2c3_to_rgb[2](C[0],C[1],C[2]);
      
/*#ifdef DEBUG		    */
      fprintf(stderr,"(C1,C2,C3 = %d,%d,%d)-->(R,G,B = %d,%d,%d)\n",C[0],C[1],C[2],R,G,B);
/*#endif		    */
      *table_cour       = R;
      *(table_cour + 1) = G;
      *(table_cour + 2) = B;
      image_ecrire_pixel(*table_rgb,table_cour);
      
      image_pixel_suivant(*table_rgb);
      table_cour +=3;
    }


  /* On passe l' image en n couleurs */
  image_debut(img);
  do
    {
      pixel = image_lire_pixel(img);
      
      indice_couleur = partition_give_cluster_nb(init_part,pixel);
      
      indice_couleur = cluster_set_give_canonic_cluster(clusters,
							indice_couleur);
      indice_couleur = equiv[indice_couleur];
      table_cour_rgb = table_C1C2C3 + 3*indice_couleur;
      
      image_ecrire_pixel(img,table_cour_rgb);
    }
  while(image_pixel_suivant(img));

  free(table_C1C2C3);
  free(equiv);
}
void CreerTable(image img,
		image *table_couleur,
		int* nb_de_couleur,
		int nb_cluster,
		int space)
{
  int nb_couleur;
  cluster_set clusters;
  image img_indice;
  partition init_part;
  long temps;

  times(&tms_debut);
  init_part = FAIRE_partition(&nb_cluster);
  clusters = FAIRE_cluster_set(img,init_part,nb_cluster,space);
  times(&tms_fin);
  temps = tms_fin.tms_utime - tms_debut.tms_utime;
  fprintf(stderr,"Temp Split+init cluster %f\n",((float)temps)/CLK_TCK);
  temps=0;
  nb_cluster = cluster_set_give_cardinal(clusters);
  if(nb_cluster > *nb_de_couleur)
    {
      temps = chrono(merge_clusters(clusters,*nb_de_couleur));
    }
  else
    *nb_de_couleur = nb_cluster;

  fprintf(stderr,"Temps de merge :  %f\n",((float)temps)/CLK_TCK);
  
  map_image(clusters,
	    table_couleur,
	    init_part,
	    img,
	    *nb_de_couleur,
	    nb_cluster,
	    space);
  DEFAIRE_partition(init_part);
  DEFAIRE_cluster_set(clusters);

  fprintf(stderr,"FIN ! \n");
}

