#include <time.h>
#include <stdio.h>
#include <ctype.h>
#include <image.h>
#include <type_obj.h>


#include "types.h"
#include "chrono.h"
#include "conversion.h"
#include "lecture_fichier_image.h"

#define UNKNOWN -1

#define NB_COLOR 7

static char* color_list_name[]=
{
  "rgb",
  "i1i2i3",
  "h1h2h3",
  "luv",
  "yiq",
  "vect_propre",
  "k1k2k3"
};
static int color_list_flag[]=
{
  RGB,
  I1I2I3,
  H1H2H3,
  LUV,
  YIQ,
  VECT_PROPRE,
  K1K2K3
};
void usage(char* nom)
{
  fprintf(stderr,"USAGE :\n\n %s nb_color  -nb_cluster nb_cluster [-space ",nom);
  fprintf(stderr,"rgb,k1k2k3,yiq,Luv,i1i2i3] ");
  fprintf(stderr,"[-map map.ppm] f1.ppm > res.ppm\n");
}
void uniformiser(char* chaine)
{
  int i=0;

  do
    {
      chaine[i] = tolower(chaine[i]);
      i++;
    }
  while(chaine[i] != '\0');

}
int choisir_argument(char* nom,
		     char* argument,
		     char* liste_valeur[],
		     int   liste_flag[],
		     int nb_valeur
		     )
{
  int i;
  
  uniformiser(argument);

  for(i=0;i<nb_valeur;i++)
    {
      if(strcmp(argument,liste_valeur[i])==0)
	return liste_flag[i];
    }
  
  usage(nom);
  exit(1);
}
int recuperer_argument(char* commande,
		       char* nom_param,
		       char* liste_valeur[],
		       int   liste_flag[],
		       int nb_valeur,
		       char* param[],
		       int* nb_param)
{
  int argument_choisi;
  int i,j;


  for(i=1;i<*nb_param;i++)
    if(strcmp(param[i],nom_param)==0)
      break;

  if(i==*nb_param)
    return UNKNOWN;
	  
  argument_choisi = choisir_argument(commande,				     
				     param[i+1],
				     liste_valeur,
				     liste_flag,
				     nb_valeur);
  
  for(j=i;j<*nb_param-2;j+=2)
    {
      param[j] = param[j+2];
      param[j+1] = param[j+3];
    }
  
  *nb_param = *nb_param-2;
  
  return argument_choisi;
}
bouleen recuperer_choix(char* commande,
			char* nom_param,
			char* param[],
			int* nb_param,
			char** argument_choisi)
{
  int i,j;


  for(i=1;i<*nb_param;i++)
    if(strcmp(param[i],nom_param)==0)
      break;

  if(i==*nb_param)
    return faux;
	  
  *argument_choisi = param[i+1];
  
  for(j=i;j<*nb_param-2;j+=2)
    {
      param[j] = param[j+2];
      param[j+1] = param[j+3];
    }
  
  *nb_param = *nb_param-2;
  
  return vrai;
}
int main(int argc, char* argv[])
{
  char *image_source,*table;
  char *commande,*argument;
  image table_couleur;
  int nb_de_couleur,nb_cluster;
  image img = FAIRE_image();
  int espace_couleur;
  long temps;    
  bouleen sauver_table;

  commande = argv[0];    
  espace_couleur = recuperer_argument(commande,
				      "-space",
				      color_list_name,
				      color_list_flag,
				      NB_COLOR,
					argv,
				      &argc
				      );
  if(espace_couleur == UNKNOWN)
    espace_couleur = RGB;
  
  if(!recuperer_choix(commande,
		      "-nb_cluster",
		      argv,
		      &argc,
		      &argument			
		      ))
    {
      usage(commande);
      exit(2);
    }
  
  nb_cluster = atoi(argument);
  sauver_table = recuperer_choix(commande,
				   "-map",
				 argv,
				 &argc,
				 &argument
				 );
  table = argument;
  if(argc != 3)
    {
      usage(commande);
      exit(1);
    }
  
  nb_de_couleur = atoi(argv[1]);
  image_source = argv[2];
  
  if(image_charger(img,image_source) == -1)
    {
      fprintf(stderr,"Image \"%s\" non charge : Probleme\n",image_source);
      exit(3);
    }
  temps = chrono(
		 CreerTable(img,
			    &table_couleur,
			    &nb_de_couleur,
			    nb_cluster,
			    espace_couleur
			    )
		 );
  fprintf(stderr,"Temps utilisateur :%f\n",((float)temps)/CLK_TCK);
  image_to_stream(img,stdout);
  if(sauver_table)
    {
      if( image_sauvegarder(table_couleur,table) )
	{
	  fprintf(stderr,"Problemes a la sauvegarde de la table\n");
	  exit(4);
	}
    }
  return 0;
}



