#include "matrice.h"
#include <math.h>

double vecteur_dist(vecteur v1,vecteur v2)
{
  double dist;
  int i;

  dist = 0.0;
  for(i=0;i<DIM;i++)
    dist += (v1[i]-v2[i])*(v1[i]-v2[i]);
  
  return dist;
}
void matrice_affiche_vect(vecteur V)
{
    int i;
    
    printf("(");
    for(i=0;i<DIM-1;i++)
	    printf("%f,",V[i]);
    printf("%f)\n",V[DIM-1]);
}

void matrice_affiche_matrice(matrice M)
{
    int i ,j;
    
    for(i=0;i<DIM;i++)
	    {
		for(j=0;j<DIM;j++)
			printf("%f ",M[i][j]);
		printf("\n");
	    }
}
void matrice_affecte_vect(vecteur v1,vecteur v2)
{
  int i;
  
  for(i=0;i<DIM;i++)
    v1[i] = v2[i];
}

double matrice_scalaire_vect(vecteur v1,vecteur v2)
{
  int i;
  double res;
  
  res = 0.0;
  for(i=0;i<DIM;i++)
    res += v1[i]*v2[i];
  
  return(res);
}
void matrice_vecteur_propre_principal(mat_covariance a,
				      vecteur v_propre,
				      vecteur x0)
{

    vecteur x,y;
    double norme_x,norme_ymx,e,lambda;
    int i,j,k;

    for(i=0;i<DIM;i++)
      x[i] = x0[i];

    do
      {
	/*  Calcul de norme de x */
	norme_x = matrice_scalaire_vect(x,x);
	norme_x = sqrt(norme_x);
	
	/* calcul de y */
		
	for(i=0;i<DIM;i++)
	  {
	    y[i]=0.0;
	    for(j=0;j<DIM;j++)
	      y[i] += a[i][j]*x[j];
	    y[i] = y[i]/norme_x;
	  }
	/* calcul de convergence */
	norme_ymx =0.0;
	for(i=0;i<DIM;i++)
	  norme_ymx +=(y[i]-x[i])*(y[i]-x[i]);
	norme_ymx = sqrt(norme_ymx);
	e = norme_ymx/norme_x;
	
	/* x = y*/
	for(i=0;i<DIM;i++)
	  x[i] = y[i];	
      }
    while(e > 0.0001);
		
    i=0;
    while((x[i] ==0)&&(i <DIM)) i++;
    if(i==DIM)
      {
	printf("PB vecteur propre nul\n");
	exit(0);
      }
    else
      {
	/* On normalise x */
	norme_x = matrice_scalaire_vect(x,x);
	norme_x = sqrt(norme_x);

	for(j=0;j<DIM;j++)
	  x[j] = x[j]/norme_x;
	y[i]=0.0;
	for(j=0;j<DIM;j++)				   
	  y[i] += a[i][j]*x[j];
		
	lambda = y[i]/x[i];
#ifdef DEBUG
	printf("lambda = %f\n",lambda);
#endif
      }
    
    /* On recupere le resultat */
    
    for(i=0;i<DIM;i++)
      v_propre[i] = x[i];
        
#ifdef DEBUG
    affiche_vect(v_propre);
#endif
}


void matrice_val_vect_propre(mat_covariance a,
			     vecteur val_propre,
			     mat_passage P,
			     matrice x0)
{

  vecteur x,y;
  double norme_x,norme_ymx,e,lambda;
  int i,j,k;
  
  for(i=0;i<DIM-1;i++)
    {
      if(i <DIM-1)
	for(j=0;j<DIM;j++)
	  x[j] = x0[i][j];

      do
	{
	  /*  Calcul de norme de x */
	  norme_x = 0.0;
	  for(j=0;j<DIM;j++)
	    norme_x += x[j]*x[j];
	  norme_x = sqrt(norme_x);
	  
	  /* calcul de y */

	  for(j=0;j<DIM;j++)
	    {
	      y[j]=0.0;
	      for(k=0;k<DIM;k++)
		y[j] += a[j][k]*x[k];
	      y[j] = y[j]/norme_x;
	    }
	  /* calcul de convergence */
	  norme_ymx =0.0;
	  for(j=0;j<DIM;j++)
	    norme_ymx +=(y[j]-x[j])*(y[j]-x[j]);
	  norme_ymx = sqrt(norme_ymx);
	  e = norme_ymx/norme_x;
			    
	  /* x = y*/
	  for(j=0;j<DIM;j++)
	    x[j] = y[j];			    
	}
      while(e > 0.0001);
		
      k=0;
      while((x[k] ==0)&&(k <DIM)) k++;
      if(k==DIM)
	{
	  printf("PB vecteur propre nul\n");
	  exit(0);
	}
      else
	{
	  /* On normalise x */
	  for(j=0;j<DIM;j++)
	    norme_x += x[j]*x[j];
	  norme_x = sqrt(norme_x);
	  for(j=0;j<DIM;j++)
	    x[j] = x[j]/norme_x;
	  y[k]=0.0;
	  for(j=0;j<DIM;j++)				   
	    y[k] += a[k][j]*x[j];
			    
	  lambda = y[k]/x[k];
	  printf("lambda%d = %f\n",i,lambda);
	  printf("x%d = ( ",i);
	  for(j=0;j<2;j++)
	    printf("%f,",x[j]);
	  printf("%f)\n",x[2]);
	  printf("\n");
	}

      for(j=0;j<DIM;j++)
	for(k=0;k<DIM;k++)
	  a[j][k] -= lambda*x[k]*x[j];

      for(j=0;j<DIM;j++)
	P[j][i] = x[j];

      val_propre[i] = lambda; 

		
    }
  /* La on utilise le fait que la matrice */
  /* est 3*3 pour en deduire le dernier vecteur propre*/
  norme_x =0.0;
  for(i=0;i<DIM;i++)
    {
      j= (i+1)%DIM;
      k= (i+2)%DIM;
      P[i][2] = P[j][0]*P[k][1] - P[k][0]*P[j][1];
      norme_x += P[i][2]*P[i][2];
    }
  for(j=0;j<DIM;j++)
    P[j][2] = P[j][2]/norme_x;
  k=0;
  while((P[k][2] ==0)&&(k <DIM)) k++;
  if(k==DIM)
    {
      printf("PB vecteur propre nul\n");
      exit(0);
    }
  else
    {
      lambda = 0.0;
      for(j=0;j<DIM;j++)
	lambda += a[k][j]*P[j][2];
      val_propre[2] = lambda/P[k][2];
    }
  printf("lambda2 = %f\n",val_propre[2]);
  printf(" x2 =(");
  for(j=0;j<2;j++)
    printf("%f,",P[j][2]);
  printf("%f)\n",P[2][2]);
  printf("\n");    
}
